/*****************************************************************************
 * ;
 * ;   (C) Unpublished Work of SENAO Networks Incorporated.  All Rights Reserved.
 * ;
 * ;       THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL,
 * ;       PROPRIETARY AND TRADESECRET INFORMATION OF SENAO INCORPORATED.
 * ;       ACCESS TO THIS WORK IS RESTRICTED TO (I) SENAO EMPLOYEES WHO HAVE A
 * ;       NEED TO KNOW TO PERFORM TASKS WITHIN THE SCOPE OF THEIR ASSIGNMENTS
 * ;       AND (II) ENTITIES OTHER THAN SENAO WHO HAVE ENTERED INTO APPROPRIATE
 * ;       LICENSE AGREEMENTS.  NO PART OF THIS WORK MAY BE USED, PRACTICED,
 * ;       PERFORMED, COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED,
 * ;       ABBRIDGED, CONDENSED, EXPANDED, COLLECTED, COMPILED, LINKED, RECAST,
 * ;       TRANSFORMED OR ADAPTED WITHOUT THE PRIOR WRITTEN CONSENT OF SENAO.
 * ;       ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD
 * ;       SUBJECT THE PERPERTRATOR TO CRIMINAL AND CIVIL LIABILITY.
 * ;
 * ;------------------------------------------------------------------------------
 * ;
 * ;    Project : ESR1221N, N2, NH. RF: RTL8188, 8192
 * ;    Creator : David Chang
 * ;    File    : rtl819x_senao.h
 * ;    Abstract:
 * ;
 * ;       Modification History:
 * ;       By              Date     Ver.   Modification Description
 * ;       --------------- -------- -----  --------------------------------------
 * ;       David           20100629        Newly Create
 * ;*****************************************************************************/
#ifndef _RTL819X_SENAO_H
#define _RTL819X_SENAO_H

/*-----------------------------------------------------------------------------
 *                     include files
 *----------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
 *                     macros, defines, typedefs, enums
 *----------------------------------------------------------------------------*/

typedef enum SN_RTL819X_LED_T
{
    SN_RTL819X_LED_ON=0,
    SN_RTL819X_LED_OFF,
    SN_RTL819X_LED_BLINK,
} SN_RTL819X_LED;

typedef enum SN_RTL819X_BTN_T
{
    SN_RTL819X_BTN_INIT=0,
    /*Below is wps behaviour*/
    SN_RTL819X_BTN_TRIGGER_24G,
	SN_RTL819X_BTN_TRIGGER_5G,
    SN_RTL819X_BTN_NON_OP,
    SN_RTL819X_BTN_RESET,
    SN_RTL819X_BTN_RESET_2_DEF,
	SN_RTL819X_BTN_FACTORY_MODE,
} SN_RTL819X_BTN;

typedef enum SN_RTL819X_BUTTON_TYPE
{
	SN_RTL819X_BUTTON_TYPE_INIT=0,
    SN_RTL819X_BUTTON_TYPE_WPS,
    SN_RTL819X_BUTTON_TYPE_RESET,
    /*Below is wps behaviour*/
} SN_RTL819X_BUTTON_TYPE;


/*-----------------------------------------------------------------------------
 *                     data declarations, extern, static, const
 *----------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
 *                     functions declarations
 *----------------------------------------------------------------------------*/
extern void rtl_gpio_set_sn_board(SN_RTL819X_LED e_sn_rtl819x_led);

#endif /*_RTL819X_SENAO_H*/
